clang-tools 6.0.0

Public Member Functions | Protected Member Functions | List of all members
clang::tidy::modernize::MakeUniqueCheck Class Reference

Replace the pattern: More...

`#include <MakeUniqueCheck.h>`

Inheritance diagram for clang::tidy::modernize::MakeUniqueCheck:
[legend]
Collaboration diagram for clang::tidy::modernize::MakeUniqueCheck:
[legend]

## Public Member Functions
| MakeUniqueCheck (StringRef Name, ClangTidyContext *Context)
Public Member Functions inherited from clang::tidy::modernize::MakeSmartPtrCheck
| MakeSmartPtrCheck (StringRef Name, ClangTidyContext *Context, StringRef MakeSmartPtrFunctionName)
void | registerMatchers (ast_matchers::MatchFinder *Finder) final
| Override this to register AST matchers with `Finder`. More...
void | registerPPCallbacks (clang::CompilerInstance &Compiler) override
void | check (const ast_matchers::MatchFinder::MatchResult &Result) final
| `ClangTidyChecks` that register ASTMatchers should do the actual work in here. More...
void | storeOptions (ClangTidyOptions::OptionMap &Opts) override
| Should store all options supported by this check with their current values or default values for options that haven't been overridden. More...
Public Member Functions inherited from clang::tidy::ClangTidyCheck
| ClangTidyCheck (StringRef CheckName, ClangTidyContext *Context)
| Initializes the check with `CheckName` and `Context`. More...
virtual void | registerPPCallbacks (CompilerInstance &Compiler)
| Override this to register `PPCallbacks` with `Compiler`. More...
DiagnosticBuilder | diag (SourceLocation Loc, StringRef Description, DiagnosticIDs::Level Level=DiagnosticIDs::Warning)
| Add a diagnostic with the check's name. More...

## Protected Member Functions
SmartPtrTypeMatcher | getSmartPointerTypeMatcher () const override
| Returns matcher that match with different smart pointer types. More...
Protected Member Functions inherited from clang::tidy::ClangTidyCheck
StringRef | getCurrentMainFile () const
| Returns the main file name of the current translation unit. More...
LangOptions | getLangOpts () const
| Returns the language options from the context. More...

## Additional Inherited Members
Protected Types inherited from clang::tidy::modernize::MakeSmartPtrCheck
using | SmartPtrTypeMatcher = ast_matchers::internal::BindableMatcher< QualType >
Protected Attributes inherited from clang::tidy::ClangTidyCheck
OptionsView | Options
Static Protected Attributes inherited from clang::tidy::modernize::MakeSmartPtrCheck
static const char | PointerType [] = "pointerType"
static const char | ConstructorCall [] = "constructorCall"
static const char | ResetCall [] = "resetCall"
static const char | NewExpression [] = "newExpression"

## Detailed Description

Replace the pattern:

std::unique_ptr<type>(new type(args...))

With the C++14 version:

std::make_unique<type>(args...)

Definition at line 28 of file MakeUniqueCheck.h.

## Constructor & Destructor Documentation

## ◆ MakeUniqueCheck()

clang::tidy::modernize::MakeUniqueCheck::MakeUniqueCheck | ( | StringRef | Name,
|  | ClangTidyContext * | Context
| ) |  |

Definition at line 18 of file MakeUniqueCheck.cpp.

## Member Function Documentation

## ◆ getSmartPointerTypeMatcher()

MakeUniqueCheck::SmartPtrTypeMatcher clang::tidy::modernize::MakeUniqueCheck::getSmartPointerTypeMatcher | ( |  | ) | const
| override protected virtual

Returns matcher that match with different smart pointer types.

Requires to bind pointer type (qualType) with PointerType string declared in this class.

Implements clang::tidy::modernize::MakeSmartPtrCheck.

Definition at line 23 of file MakeUniqueCheck.cpp.

References clang::tidy::modernize::MakeSmartPtrCheck::PointerType.

The documentation for this class was generated from the following files:

- MakeUniqueCheck.h
- MakeUniqueCheck.cpp